function varargout = PointSourceColocForJosephCabralProcessGUI(varargin)
    gui_Singleton = 1;
    gui_State = struct('gui_Name',       mfilename, ...
                       'gui_Singleton',  gui_Singleton, ...
                       'gui_OpeningFcn', @PointSourceColocForJosephCabralProcessGUI_OpeningFcn, ...
                       'gui_OutputFcn',  @PointSourceColocForJosephCabralProcessGUI_OutputFcn, ...
                       'gui_LayoutFcn',  [] , ...
                       'gui_Callback',   []);
    if nargin && ischar(varargin{1})
        gui_State.gui_Callback = str2func(varargin{1});
    end

    if nargout
        [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
    else
        gui_mainfcn(gui_State, varargin{:});
    end
    % End initialization code - DO NOT EDIT
end

% --- Executes just before maskRefinementProcessGUI is made visible.
function PointSourceColocForJosephCabralProcessGUI_OpeningFcn(hObject, eventdata, handles, varargin)

    processGUI_OpeningFcn(hObject, eventdata, handles, varargin{:},'initChannel',1);

%     % Parameters setup 
    userData = get(handles.figure1, 'UserData');
    funParams = userData.crtProc.funParams_;
    set(handles.('editProximityThreshold'), 'String', funParams.ProximityThreshold);

    % Update user data and GUI data
    handles.output = hObject;
    set(handles.figure1, 'UserData', userData);
    guidata(hObject, handles);
end


% --- Outputs from this function are returned to the command line.
function varargout = PointSourceColocForJosephCabralProcessGUI_OutputFcn(hObject, eventdata, handles) 
    % varargout  cell array for returning output args (see VARARGOUT);
    % hObject    handle to figure
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)

    % Get default command line output from handles structure
    varargout{1} = handles.output;
end


% --- Executes on button press in pushbutton_cancel.
function pushbutton_cancel_Callback(hObject, eventdata, handles)
    % hObject    handle to pushbutton_cancel (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)
    delete(handles.figure1);
end


% --- Executes during object deletion, before destroying properties.
function figure1_DeleteFcn(hObject, ~, handles)
    % Notify the package GUI that the setting panel is closed
    userData = get(handles.figure1, 'UserData');

    delete(userData.helpFig(ishandle(userData.helpFig))); 

    set(handles.figure1, 'UserData', userData);
    guidata(hObject,handles);
end

% --- Executes on key press with focus on pushbutton_done and none of its controls.
function pushbutton_done_KeyPressFcn(~, eventdata, handles)
    if strcmp(eventdata.Key, 'return')
        pushbutton_done_Callback(handles.pushbutton_done, [], handles);
    end
end

% --- Executes on key press with focus on figure1 and none of its controls.
function figure1_KeyPressFcn(~, eventdata, handles)
    if strcmp(eventdata.Key, 'return')
        pushbutton_done_Callback(handles.pushbutton_done, [], handles);
    end
end

% --- Executes on button press in pushbutton_done.
function pushbutton_done_Callback(hObject, eventdata, handles)
    % Call back function of 'Apply' button

    if isempty(get(handles.listbox_selectedChannels, 'String'))
       errordlg('Please select one reference channel from ''Available Channels''.','Setting Error','modal') 
        return;
    end
    if numel(get(handles.listbox_selectedChannels, 'String')) > 1
       errordlg('Please select only one reference channel from ''Available Channels''.','Setting Error','modal') 
        return;
    end
    
	userData = get(handles.figure1, 'UserData');
    funParams = userData.crtProc.funParams_;
    
    channelIndex = get (handles.listbox_selectedChannels, 'Userdata');
    funParams.ChannelIndex = channelIndex;
    
    value = str2double(get(handles.('editProximityThreshold'),{'String'}));
    if isnan(value) || value < 0
        errordlg('proximity threshold should be >= 0','Setting Error','modal')
        return;
    end
    funParams.ProximityThreshold = round(value);
    
    % Set parameters and update main window
    processGUI_ApplyFcn(hObject, eventdata, handles,funParams);
end



function editProximityThreshold_Callback(hObject, eventdata, handles)
% hObject    handle to editProximityThreshold (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editProximityThreshold as text
%        str2double(get(hObject,'String')) returns contents of editProximityThreshold as a double
end


% --- Executes during object creation, after setting all properties.
function editProximityThreshold_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editProximityThreshold (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
end
