function imgLoG  = logPointSourceDetection(img, mask, sigma, alpha)

% possible alternative: /home/mc457/matlab/Danuser/common/detectionAlgorithms/detectSpotsWT.m

if ~isa(img, 'double')
    img = double(img);
end

% Gaussian kernel
w = ceil(4*sigma);
x = -w:w;
g = exp(-x.^2/(2*sigma^2));

% convolutions
imgXT = padarrayXT(img, [w w], 'symmetric');
fg = conv2(g', g, imgXT, 'valid');

% Laplacian of Gaussian
gx2 = g.*x.^2;
imgLoG = 2*fg/sigma^2 - (conv2(g, gx2, imgXT, 'valid')+conv2(gx2, g, imgXT, 'valid'))/sigma^4;
imgLoG = imgLoG / (2*pi*sigma^2);

% select by threshold
% imgLoG = normalize(imgLoG);
% bw = imregionalmax(imgLoG).*(imgLoG > alpha);
% imgLoG = bw.*imgLoG;

% select by percentile
% PSMags = imregionalmax(imgLoG).*imgLoG;
% psmags = PSMags(PSMags > 0);
% psmags = psmags(:);
% pct = prctile(psmags,100*alpha);
% imgLoG = PSMags.*(PSMags > pct);

% % select by robust statistics
% PSMags = imregionalmax(imgLoG).*imgLoG;
% PSMagsB = PSMags.*not(mask);
% % PSMagsF = PSMags.*mask;
% psmagsB = PSMagsB(PSMagsB > 0);
% % psmagsF = PSMagsF(PSMagsF > 0);
% psmagsB = psmagsB(:);
% % psmagsF = psmagsF(:);
% rmB = median(psmagsB);
% rsB = mad(psmagsB,1);
% sigma = 1.4826*rsB;
% % figure, hist(psmagsB,100)
% % figure, hist(psmagsF,100)
% % pause
% imgLoG = PSMags.*(PSMags > rmB+alpha*sigma);

% select by robust statistics
PSMags = imregionalmax(imgLoG).*imgLoG;

% border = 100;
% C = img(border:end-border,border:end-border);
% B = imbinarize(normalize(C));
% BB = zeros(size(img));
% BB(border:end-border,border:end-border) = B;
% BgMask = BB & not(mask);
BgMask = not(mask);
% FgMask = mask;

PSMagsB = PSMags.*BgMask;
% PSMagsF = PSMags.*FgMask;
psmagsB = PSMagsB(PSMagsB > 0);
% psmagsF = PSMagsF(PSMagsF > 0);
psmagsB = psmagsB(:);
% psmagsF = psmagsF(:);
rmB = median(psmagsB);
rsB = mad(psmagsB,1);
sigma = 1.4826*rsB;
% figure, hist(psmagsB,100)
% figure, hist(psmagsF,100)
imgLoG = PSMags.*(PSMags > rmB+alpha*sigma);

end