classdef MaskObjectBinningProcess < MaskProcessingProcess
% MASKOBJECTBINNINGPROCESS is a mask processing class that relabels the
% input masks into different numbers according to object areas or other
% properties.
    methods (Access = public)
        function obj = MaskObjectBinningProcess(owner, varargin)
            % Input check
            ip = inputParser;
            ip.addRequired('owner',@(x) isa(x,'MovieData'));
            ip.addOptional('outputDir',owner.outputDirectory_,@ischar);
            ip.addOptional('funParams',[],@isstruct);
            %ip.addOptional('funName',[],@ischar);
            ip.parse(owner,varargin{:});
            outputDir = ip.Results.outputDir;
            funParams = ip.Results.funParams;
            super_args{1} = owner;
            %if isempty(funName)
            super_args{2} = MaskObjectBinningProcess.getName;
            %else
            %    super_args{2} = funName;
            %end
            super_args{3} = @binningMovieObjects;
            if isempty(funParams)  % Default funParams
                funParams = MaskObjectBinningProcess.getDefaultParams(owner,outputDir);
            end
            super_args{4} = funParams;
            obj = obj@MaskProcessingProcess(super_args{:});
        end
        
        
    end
    methods(Static)
        function name = getName()
            name = 'Mask Object Binning';
        end
        function h = GUI()
            h = @binningMaskByPropsGUI;
        end
        function funParams = getDefaultParams(owner,varargin)
            % Input check
            ip=inputParser;
            ip.addRequired('owner',@(x) isa(x,'MovieData'));
            ip.addOptional('outputDir',owner.outputDirectory_,@ischar);
            ip.parse(owner, varargin{:})
            outputDir=ip.Results.outputDir;
            
            % Set default parameters
            funParams.ChannelIndex = 1:numel(owner.channels_);
            funParams.OutputDirectory = [outputDir  filesep 'MaskObjectBinning'];
            funParams.ProcessIndex = [];%Default is to use raw 
            funParams.methodInd = 1;
            funParams.distanceThreshold = 50;
        end
    end
end