function varargout = binningMaskByPropsGUI(varargin)
% anisoGaussianDetectionProcessGUI M-file for anisoGaussianDetectionProcessGUI.fig
%      anisoGaussianDetectionProcessGUI, by itself, creates a new anisoGaussianDetectionProcessGUI or raises the existing
%      singleton*.
%
%      H = anisoGaussianDetectionProcessGUI returns the handle to a new anisoGaussianDetectionProcessGUI or the handle to
%      the existing singleton*.
%
%      anisoGaussianDetectionProcessGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in anisoGaussianDetectionProcessGUI.M with the given input arguments.
%
%      anisoGaussianDetectionProcessGUI('Property','Value',...) creates a new anisoGaussianDetectionProcessGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before anisoGaussianDetectionProcessGUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to anisoGaussianDetectionProcessGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help anisoGaussianDetectionProcessGUI

% Last Modified by GUIDE v2.5 10-Mar-2015 15:02:13

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @binningMaskByPropsGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @binningMaskByPropsGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before anisoGaussianDetectionProcessGUI is made visible.
function binningMaskByPropsGUI_OpeningFcn(hObject, eventdata, handles, varargin)

processGUI_OpeningFcn(hObject, eventdata, handles, varargin{:},'initChannel',1);
% 
% % Set-up parameters
% userData=get(handles.figure1,'UserData');
% % Update GUI user data
% set(handles.figure1, 'UserData', userData);
% % property default settings.
% Set-up parameters
userData=get(handles.figure1,'UserData');
iProcP = userData.MD.getProcessIndex('CalcMaskPropsProcess',1,0);
calcProcess = userData.MD.processes_{iProcP}; % check if iProcP exist, for other packages.
%defaultSelectedProps = calcProcess.funParams_.selectedProps;
%mpcToUse = calcProcess.loadChannelOutput(1);
funParams = userData.crtProc.funParams_;
funParamsPropsCalc = calcProcess.funParams_;
if isfield(funParamsPropsCalc, 'thresholdableProps') %%!!!!if there's nothing thresholdable pop a warning.
    defaultSelectedProps = funParamsPropsCalc.thresholdableProps{1}; %default first channel.
    if isempty(defaultSelectedProps)
        warndlg('There is no thresholdable properties available. Please redo the calculation process.');
    else
        newMinMaxRange = funParamsPropsCalc.newMinMaxRange{1}; %default first channel
        funParams.newMinMaxRange = funParamsPropsCalc.newMinMaxRange;
        funParams.thresholdableProps = funParamsPropsCalc.thresholdableProps;
    end
else
    tempmpc = MaskPropsCalc;
    [~, listswitch] = tempmpc.MatchLists(funParamsPropsCalc.selectedProps);
    defaultSelectedProps = tempmpc.getAllList;
    defaultSelectedProps = defaultSelectedProps((listswitch'&tempmpc.getDefaultThresholdableSwitch)>0);
    newMinMaxRange = [-Inf(size(defaultSelectedProps,1),1),Inf(size(defaultSelectedProps,1),1)];
end
set(handles.propertylistboxS,'String',defaultSelectedProps);
if isfield(userData.crtProc.funParams_, 'selectedPropsV')
set(handles.propertylistboxS,'Value',userData.crtProc.funParams_.selectedPropsV);
end
if isfield(userData.crtProc.funParams_, 'rangeSettingMatrix')
%     for ipp = 1:length(userData.crtProc.funParams_.defaultThresProps)
%         paramInd = find(strcmp(userData.crtProc.funParams_.defaultThresProps{ipp}, defaultSelectedProps)>0);
%         defaultRangSettingM(paramInd, :) = userData.crtProc.funParams_.defaultThresRange(ipp,:);
%     end
    defaultRangSettingM = funParams.rangeSettingMatrix{1};
else
    % set the default string here. get newMinMaxRange first row first
    % channel and get min, max, 3 bins,first property
    % get each bin width, default equally divided:
    
    
    
    defaultRangSettingM = [0.5,5,20,100,Inf]; 
    
    defaultRSwidth = (newMinMaxRange(1,2)-newMinMaxRange(1,1))/3; % by default three divisions.
%     defaultRangSettingM = [-Inf,newMinMaxRange(1,1)+ defaultRSwidth,...
%         newMinMaxRange(1,1)+2*defaultRSwidth,Inf];
    funParams.rangeSettingMatrix{1} = defaultRangSettingM;
end
update_Range(handles,newMinMaxRange,defaultRangSettingM,0);
funParams.OutputDirectory = userData.crtProc.funParams_.OutputDirectory;
funParams.selectedProps = funParamsPropsCalc.selectedProps;
userData.crtProc.setParameters(funParams);
handles.output = hObject;
guidata(hObject, handles);

function [rangeSettingMatrix, handles] = update_Range(handles,newMinMaxRange,rangeSettingMatrix, flag_forEdit)
% everytime a new thresholdable property is clicked (or this GUI is first started this function is called.)
% per channel thing. no funparams involved.
hsetting = findobj('Tag','propertylistboxS');
if isempty(hsetting)
    return;
end
currentselettion = get(handles.propertylistboxS, 'Value');
binsString = get(handles.Bins, 'String');
if flag_forEdit > 0
rangeSettingMatrix = str2num(binsString);
end
if nargin > 1
set(handles.maxValue, 'String', ['Max Value   ' num2str(newMinMaxRange(currentselettion, 2))]);
set(handles.minValue, 'String', ['Min Value   ' num2str(newMinMaxRange(currentselettion, 1))]);
end
rangeSettingMatrixstring = [];
if nargin > 2
    for i = 1:length(rangeSettingMatrix)
        rangeSettingMatrixstring = [rangeSettingMatrixstring, num2str(rangeSettingMatrix(i),'%10.2f'),','];
    end
    set(handles.Bins, 'String', rangeSettingMatrixstring);
end

function listbox_selectedChannels_Callback(hObject, eventdata, handles, flag_forEdit)
currentChanSelettion = get(handles.listbox_selectedChannels, 'Value');
% update thresholdable params: could be different across channels.
userData=get(handles.figure1,'UserData');
% iProcP = userData.MD.getProcessIndex('CalcMaskPropsProcess',1,0);
% calcProcess = userData.MD.processes_{iProcP}; % check if iProcP exist, for other packages.
%defaultSelectedProps = calcProcess.funParams_.selectedProps;
%mpcToUse = calcProcess.loadChannelOutput(1);

funParams = userData.crtProc.funParams_;
if isfield(funParams, 'thresholdableProps')&& isfield(funParams, 'newMinMaxRange')%%!!!!if there's nothing thresholdable pop a warning.
defaultSelectedProps = funParams.thresholdableProps{currentChanSelettion};
    if isempty(defaultSelectedProps)
        warndlg('There is no thresholdable properties available. Please redo the calculation process.');
    else
        % update ranges (for sure will be different.)
        newMinMaxRange = funParams.newMinMaxRange{currentChanSelettion}; 
    end
else
    tempmpc = MaskPropsCalc;
    [~, listswitch] = tempmpc.MatchLists(funParams.selectedProps);
    defaultSelectedProps = tempmpc.getAllList;
    defaultSelectedProps = defaultSelectedProps((listswitch'&tempmpc.getDefaultThresholdableSwitch)>0);
    newMinMaxRange = [-Inf(size(defaultSelectedProps,1),1),Inf(size(defaultSelectedProps,1),1)];
end
set(handles.propertylistboxS,'String',defaultSelectedProps);
% get the saved range from funparams from crtProc
if length(funParams.rangeSettingMatrix) >=currentChanSelettion
    if isfield(funParams, 'rangeSettingMatrix') && ~isempty(funParams.rangeSettingMatrix)&& ~isempty(funParams.rangeSettingMatrix{currentChanSelettion});
        rangeSettingMatrix = funParams.rangeSettingMatrix{currentChanSelettion};
    else
        rangeSettingMatrix = [Inf(size(newMinMaxRange,1),1),-Inf(size(newMinMaxRange,1),1)];
    end
rangeSettingMatrix = update_Range(handles,newMinMaxRange,rangeSettingMatrix,flag_forEdit);
funParams.rangeSettingMatrix{currentChanSelettion} = rangeSettingMatrix;
userData.crtProc.setParameters(funParams);
hset = findobj('Tag', 'propertylistboxS');

if isempty(hset)
    return;
end
handles.output = hObject;
guidata(hObject, handles);
end



    
    
    

% --- Outputs from this function are returned to the command line.
function varargout = binningMaskByPropsGUI_OutputFcn(~, ~, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on button press in pushbutton_cancel.
function pushbutton_cancel_Callback(~, ~, handles)
% Delete figure
delete(handles.figure1);

% --- Executes during object deletion, before destroying properties.
function figure1_DeleteFcn(hObject, ~, handles)
% Notify the package GUI that the setting panel is closed
userData = get(handles.figure1, 'UserData');
if(isempty(userData)), userData = struct(); end;
if isfield(userData, 'helpFig') && ishandle(userData.helpFig)
   delete(userData.helpFig) 
end

set(handles.figure1, 'UserData', userData);
guidata(hObject,handles);


% --- Executes on key press with focus on pushbutton_done and none of its controls.
function pushbutton_done_KeyPressFcn(~, eventdata, handles)

if strcmp(eventdata.Key, 'return')
    pushbutton_done_Callback(handles.pushbutton_done, [], handles);
end

% --- Executes on key press with focus on figure1 and none of its controls.
function figure1_KeyPressFcn(~, eventdata, handles)

if strcmp(eventdata.Key, 'return')
    pushbutton_done_Callback(handles.pushbutton_done, [], handles);
end

% --- Executes on button press in pushbutton_done.
function pushbutton_done_Callback(hObject, eventdata, handles)
userData=get(handles.figure1,'UserData');
% iProcP = userData.MD.getProcessIndex('CalcMaskPropsProcess',1,0);
% calcProcess = userData.MD.processes_{iProcP}; % check if iProcP exist, for other packages.
%defaultSelectedProps = calcProcess.funParams_.selectedProps;
%mpcToUse = calcProcess.loadChannelOutput(1);

funParams = userData.crtProc.funParams_;
% -------- Check user input --------

% need: channel number, property list, nothing else.
if isempty(get(handles.listbox_selectedChannels, 'String'))
    errordlg('Please select at least one input channel from ''Available Channels''.','Setting Error','modal')
    return;
end


%Get selected image channels
channelIndex = get(handles.listbox_selectedChannels, 'Userdata');
if isempty(channelIndex)
    errordlg('Please select at least one input channel from ''Available Channels''.','Setting Error','modal')
    return;
end
funParams.ChannelIndex = channelIndex;

%Get Property 
selectedProps = get(handles.propertylistboxS, 'String');
spv = get(handles.propertylistboxS, 'Value');
funParams.selectedProps = selectedProps{spv};
funParams.selectedPropsV = spv;
funParams.copySavetag = get(handles.copySavetag, 'Value');
binsString = get(handles.Bins, 'String');
rangeSettingMatrix = str2num(binsString);
funParams.rangeSettingMatrix{1} = rangeSettingMatrix;

% if isfield(funParams, 'rangeSettingMatrix')
%     rangeSettingMatrix = funParams.rangeSettingMatrix{1};
%     
% else
%     rangeSettingMatrix = [Inf(size(newMinMaxRange,1),1),-Inf(size(newMinMaxRange,1),1)];
% end
% if isfield(funParams, 'newMinMaxRange')
%      newMinMaxRange = funParams.newMinMaxRange{1}; 
% else
%      newMinMaxRange = [-Inf(size(rangeSettingMatrix,1),1),Inf(size(rangeSettingMatrix,1),1)];
% end
% % rangeSettingMatrix = update_Range(handles,newMinMaxRange,rangeSettingMatrix,0);
%  funParams.rangeSettingMatrix{1} = rangeSettingMatrix;

% Add 64-bit warning
is64bit = ~isempty(regexp(computer ,'64$', 'once'));
if ~is64bit
    warndlg(['Your Matlab version is not detected as 64-bit. Please note '....
        'the point source detection uses compiled MEX files which '...
        'are not provided for 32-bit.'],...
        'Setting Error','modal');
end
%userData.crtProc.setParameters(funParams);
processGUI_ApplyFcn(hObject, eventdata, handles,funParams);






% --- Executes on selection change in propertylistboxS.
function propertylistboxS_Callback(hObject, eventdata, handles)
% hObject    handle to propertylistboxS (see GCBO)newMinMaxRange = funParams.newMinMaxRange{currentChanSelettion}; 
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns propertylistboxS contents as cell array
%        contents{get(hObject,'Value')} returns selected item from propertylistboxS
userData=get(handles.figure1,'UserData');
% iProcP = userData.MD.getProcessIndex('CalcMaskPropsProcess',1,0);
% calcProcess = userData.MD.processes_{iProcP}; % check if iProcP exist, for other packages.
%defaultSelectedProps = calcProcess.funParams_.selectedProps;
%mpcToUse = calcProcess.loadChannelOutput(1);
currentChanSelettion = get(handles.listbox_selectedChannels, 'Value');
funParams = userData.crtProc.funParams_;
if isfield(funParams, 'thresholdableProps')&&isfield(funParams, 'newMinMaxRange') %%!!!!if there's nothing thresholdable pop a warning.
defaultSelectedProps = funParams.thresholdableProps;
    if isempty(defaultSelectedProps)
        warndlg('There is no thresholdable properties available. Please redo the calculation process.');
    else
        newMinMaxRange = funParams.newMinMaxRange{currentChanSelettion};
        
    end
else
    tempmpc = MaskPropsCalc;
    [~, listswitch] = tempmpc.MatchLists(funParams.selectedProps);
    defaultSelectedProps = tempmpc.getAllList;
    defaultSelectedProps = defaultSelectedProps((listswitch'&tempmpc.getDefaultThresholdableSwitch)>0);
    newMinMaxRange = [-Inf(size(defaultSelectedProps,1),1),Inf(size(defaultSelectedProps,1),1)];
end
currentselettion = get(handles.propertylistboxS, 'Value');
defaultRSwidth = (newMinMaxRange(currentselettion,2)-newMinMaxRange(currentselettion,1))/3;
    rangeSettingMatrix = [0.5,5,20,100,Inf]; 
% rangeSettingMatrix = [-Inf,newMinMaxRange(currentselettion,1)+ defaultRSwidth,...
%     newMinMaxRange(currentselettion,1)+2*defaultRSwidth,Inf];
rangeSettingMatrix = update_Range(handles,newMinMaxRange, rangeSettingMatrix,0);

funParams.rangeSettingMatrix{currentChanSelettion} = rangeSettingMatrix;
userData.crtProc.setParameters(funParams);



% --- Executes during object creation, after setting all properties.
function propertylistboxS_CreateFcn(hObject, eventdata, handles)
% hObject    handle to propertylistboxS (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on button press in checkbox_all.
function checkbox_all_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_all (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_all



% function upperLimit_Callback(hObject, eventdata, handles)
% % hObject    handle to upperLimit (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% % handles    structure with handles and user data (see GUIDATA)
% 
% % Hints: get(hObject,'String') returns contents of upperLimit as text
% %        str2double(get(hObject,'String')) returns contents of upperLimit as a double
% rangeSettingMatrix = update_Range(handles);


% --- Executes during object creation, after setting all properties.
function upperLimit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to upperLimit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% function lowerLimit_Callback(hObject, eventdata, handles)
% % hObject    handle to lowerLimit (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% % handles    structure with handles and user data (see GUIDATA)
% 
% % Hints: get(hObject,'String') returns contents of lowerLimit as text-Inf
% %        str2double(get(hObject,'String')) returns contents of lowerLimit as a double
% rangeSettingMatrix = update_Range(handles);

% --- Executes during object creation, after setting all properties.
function lowerLimit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to lowerLimit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Bins_Callback(hObject, eventdata, handles)
% hObject    handle to Bins (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Bins as text
%        str2double(get(hObject,'String')) returns contents of Bins as a double


% --- Executes during object creation, after setting all properties.
function Bins_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Bins (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in copySavetag.
function copySavetag_Callback(hObject, eventdata, handles)
% hObject    handle to copySavetag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of copySavetag
