function varargout = calcMaskPropsGUI(varargin)
% anisoGaussianDetectionProcessGUI M-file for anisoGaussianDetectionProcessGUI.fig
%      anisoGaussianDetectionProcessGUI, by itself, creates a new anisoGaussianDetectionProcessGUI or raises the existing
%      singleton*.
%
%      H = anisoGaussianDetectionProcessGUI returns the handle to a new anisoGaussianDetectionProcessGUI or the handle to
%      the existing singleton*.
%
%      anisoGaussianDetectionProcessGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in anisoGaussianDetectionProcessGUI.M with the given input arguments.
%
%      anisoGaussianDetectionProcessGUI('Property','Value',...) creates a new anisoGaussianDetectionProcessGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before anisoGaussianDetectionProcessGUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to anisoGaussianDetectionProcessGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help anisoGaussianDetectionProcessGUI

% Last Modified by GUIDE v2.5 23-Feb-2015 16:25:39

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @calcMaskPropsGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @calcMaskPropsGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before anisoGaussianDetectionProcessGUI is made visible.
function calcMaskPropsGUI_OpeningFcn(hObject, eventdata, handles, varargin)

processGUI_OpeningFcn(hObject, eventdata, handles, varargin{:},'initChannel',1);

% Set-up parameters
userData=get(handles.figure1,'UserData');
% Update GUI user data
set(handles.figure1, 'UserData', userData);
% property default settings.
% Set-up parameters
userData=get(handles.figure1,'UserData');
% initialized MaskPropsCalc object
defaultProps = MaskPropsCalc;
funParams = userData.crtProc.funParams_;
if isfield(funParams, 'selectedProps')
defaultSelectedProps = funParams.selectedProps;
[~, ~, defaultProps] = MatchLists(defaultProps, defaultSelectedProps);
yetSelectedProps = defaultProps.getNotCalcPropsList;
else
%allPropsList = defaultProps.PropertyList;
defaultSelectedProps = defaultProps.getCalcPropsList;
yetSelectedProps = defaultProps.getNotCalcPropsList;
end
set(handles.propertylistboxA,'String',yetSelectedProps);
set(handles.propertylistboxS,'String',defaultSelectedProps);



%Setup mask process list box
segProc =  cellfun(@(x) isa(x,'MaskProcess'),userData.MD.processes_);
segProcID=find(segProc);
segProcNames = cellfun(@(x) x.getName(),userData.MD.processes_(segProc),'Unif',false);
segProcString = vertcat('Choose later',segProcNames(:));
segProcData=horzcat({[]},num2cell(segProcID));
segProcValue = find(cellfun(@(x) isequal(x,funParams.MaskProcessIndex),segProcData));
if isempty(segProcValue), segProcValue = 1; end
set(handles.popupmenu_SegProcessIndex,'String',segProcString,...
    'UserData',segProcData,'Value',segProcValue);
% set units
set(handles.saveresultsin,'String',{'mm', 'um', 'nm', 'pixel'},...
    'Value',funParams.saveresultsas);
%set saveResults in 

handles.output = hObject;
guidata(hObject, handles);

% --- Outputs from this function are returned to the command line.
function varargout = calcMaskPropsGUI_OutputFcn(~, ~, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on button press in pushbutton_cancel.
function pushbutton_cancel_Callback(~, ~, handles)
% Delete figure
delete(handles.figure1);

% --- Executes during object deletion, before destroying properties.
function figure1_DeleteFcn(hObject, ~, handles)
% Notify the package GUI that the setting panel is closed
userData = get(handles.figure1, 'UserData');
if(isempty(userData)), userData = struct(); end;
if isfield(userData, 'helpFig') && ishandle(userData.helpFig)
   delete(userData.helpFig) 
end

set(handles.figure1, 'UserData', userData);
guidata(hObject,handles);


% --- Executes on key press with focus on pushbutton_done and none of its controls.
function pushbutton_done_KeyPressFcn(~, eventdata, handles)

if strcmp(eventdata.Key, 'return')
    pushbutton_done_Callback(handles.pushbutton_done, [], handles);
end

% --- Executes on key press with focus on figure1 and none of its controls.
function figure1_KeyPressFcn(~, eventdata, handles)

if strcmp(eventdata.Key, 'return')
    pushbutton_done_Callback(handles.pushbutton_done, [], handles);
end

% --- Executes on button press in pushbutton_done.
function pushbutton_done_Callback(hObject, eventdata, handles)

% -------- Check user input --------

% need: channel number, property list, nothing else.
if isempty(get(handles.listbox_selectedChannels, 'String'))
    errordlg('Please select at least one input channel from ''Available Channels''.','Setting Error','modal')
    return;
end


%Get selected image channels
channelIndex = get(handles.listbox_selectedChannels, 'Userdata');
if isempty(channelIndex)
    errordlg('Please select at least one input channel from ''Available Channels''.','Setting Error','modal')
    return;
end
funParams.ChannelIndex = channelIndex;

%Get Property List
selectedProps = get(handles.propertylistboxS, 'String');
funParams.selectedProps = selectedProps;

% Retrieve mask process index and class (for propagation)
props=get(handles.popupmenu_SegProcessIndex,{'UserData','Value'});
funParams.saveresultsas = get(handles.saveresultsin, 'Value');
funParams.MaskProcessIndex = props{1}{props{2}};


% Add 64-bit warning
is64bit = ~isempty(regexp(computer ,'64$', 'once'));
if ~is64bit
    warndlg(['Your Matlab version is not detected as 64-bit. Please note '....
        'the point source detection uses compiled MEX files which '...
        'are not provided for 32-bit.'],...
        'Setting Error','modal');
end

processGUI_ApplyFcn(hObject, eventdata, handles,funParams);




% --- Executes on button press in pushbutton_saveChannelParams.
function pushbutton_saveChannelParams_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_saveChannelParams (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%Get settings for the current channel before switching to another
iChan = get(handles.popupmenu_CurrentChannel,'Value');

%userData=get(handles.figure1,'UserData');
funParams = get(handles.popupmenu_CurrentChannel,'UserData');

for i =1 : numel(funParams.PerChannelParams)
    paramName = funParams.PerChannelParams{i};
    if islogical(funParams.(paramName))
        parVal = get(handles.(['edit_' paramName]), 'Value');
        funParams.(paramName)(iChan) = parVal;
    elseif iscell(funParams.(paramName))   
        parVal = get(handles.(['edit_' paramName]), 'String');
        funParams.(paramName)(iChan) = parVal;
    else
        parVal = get(handles.(['edit_' paramName]), 'String');
        funParams.(paramName)(iChan) = str2double(parVal);
    end
        
end

set(handles.popupmenu_CurrentChannel,'UserData',funParams);




% --- Executes on selection change in propertylistboxA.
function propertylistboxA_Callback(hObject, eventdata, handles)
% hObject    handle to propertylistboxA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns propertylistboxA contents as cell array
%        contents{get(hObject,'Value')} returns selected item from propertylistboxA


% --- Executes during object creation, after setting all properties.
function propertylistboxA_CreateFcn(hObject, eventdata, handles)
% hObject    handle to propertylistboxA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in selectallP.
function selectallP_Callback(hObject, eventdata, handles)
% hObject    handle to selectallP (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of selectallP
selectallPStatus = get(hObject,'Value');
if selectallPStatus > 0
    yetSProps = get(handles.propertylistboxA, 'String');
    alreadySProps = get(handles.propertylistboxS, 'String');
    combProps = cat(1, yetSProps, alreadySProps);
    set(handles.propertylistboxS, 'Value', 1);
    set(handles.propertylistboxS, 'String', combProps);
    set(handles.propertylistboxA, 'String', {});
else
    yetSProps = get(handles.propertylistboxA, 'String');
    alreadySProps = get(handles.propertylistboxS, 'String');
    combProps = cat(1, yetSProps, alreadySProps);
    set(handles.propertylistboxA, 'Value', 1);
    set(handles.propertylistboxA, 'String', combProps);
    set(handles.propertylistboxS, 'String', {});
end


% --- Executes on button press in selectProps.
function selectProps_Callback(hObject, eventdata, handles)
% hObject    handle to selectProps (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
yetSProps = get(handles.propertylistboxA, 'String');
if ~isempty(yetSProps)
    selectedPV = get(handles.propertylistboxA, 'Value');
    selectedProps = yetSProps(selectedPV);
    % pump it to the right box
    currProps = get(handles.propertylistboxS, 'String');
    currProps = cat(1,currProps, selectedProps);
    set(handles.propertylistboxS, 'String', currProps);
    % remove the props on the right
    allpV = 1:length(yetSProps); allpV(selectedPV) = [];
    yetSProps = yetSProps(allpV);
    set(handles.propertylistboxA, 'Value',1);
    set(handles.propertylistboxA, 'String', yetSProps);
end




% --- Executes on button press in deleteProps.
function deleteProps_Callback(hObject, eventdata, handles)
% hObject    handle to deleteProps (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
yetSProps = get(handles.propertylistboxS, 'String');
if ~isempty(yetSProps)
    selectedPV = get(handles.propertylistboxS, 'Value');
    selectedProps = yetSProps(selectedPV);
    % pump it to the right box
    currProps = get(handles.propertylistboxA, 'String');
    currProps = cat(1,currProps, selectedProps);
    set(handles.propertylistboxA, 'String', currProps);
    % remove the props on the right
    allpV = 1:length(yetSProps); allpV(selectedPV) = [];
    yetSProps = yetSProps(allpV);
    set(handles.propertylistboxS, 'Value', 1);
    set(handles.propertylistboxS, 'String', yetSProps);
end

% --- Executes on selection change in propertylistboxS.
function propertylistboxS_Callback(hObject, eventdata, handles)
% hObject    handle to propertylistboxS (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns propertylistboxS contents as cell array
%        contents{get(hObject,'Value')} returns selected item from propertylistboxS


% --- Executes during object creation, after setting all properties.
function propertylistboxS_CreateFcn(hObject, eventdata, handles)
% hObject    handle to propertylistboxS (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on button press in checkbox_all.
function checkbox_all_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_all (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_all


% --- Executes on selection change in popupmenu_SegProcessIndex.
function popupmenu_SegProcessIndex_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_SegProcessIndex (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_SegProcessIndex contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_SegProcessIndex
% Retrieve selected process ID
props= get(handles.popupmenu_SegProcessIndex,{'UserData','Value'});
procID = props{1}{props{2}};

% Read process and check available channels
userData = get(handles.figure1, 'UserData');

if(isempty(userData)), userData = struct(); end;

if isempty(procID)
    allChannelIndex=1:numel(userData.MD.channels_);
else
    allChannelIndex = find(userData.MD.processes_{procID}.checkChannelOutput);
end

% Set up available channels listbox
if ~isempty(allChannelIndex)
    if isempty(procID)
        channelString = userData.MD.getChannelPaths(allChannelIndex);
    else
        channelString = userData.MD.processes_{procID}.outFilePaths_(1,allChannelIndex);
    end
else
    channelString = userData.MD.getChannelPaths(allChannelIndex);
    allChannelIndex=1:numel(userData.MD.channels_);
end
%set(handles.listbox_availableMaskChannels,'String',channelString,'UserData',allChannelIndex);
set(handles.listbox_availableChannels,'String',channelString,'UserData',allChannelIndex);
% Set up selected channels listbox
%channelIndex = get(handles.listbox_selectedMaskChannels, 'UserData');
channelIndex = get(handles.listbox_selectedChannels, 'UserData');
%channelIndex(~ismember(channelIndex,allChannelIndex)) = [];%So that indices may repeat, and handles empty better than intersect
if ~isempty(channelIndex)
    if isempty(procID)
        channelString = userData.MD.getChannelPaths(channelIndex);
    else
        channelString = userData.MD.processes_{procID}.outFilePaths_(1,channelIndex);
        if isempty(channelString{1})
            channelString = userData.MD.getChannelPaths(allChannelIndex);
        end  
    end
else
    channelIndex = 1;
    channelString = userData.MD.getChannelPaths(allChannelIndex);
    %Because the intersect command returns a 0x1 instead of 0x0 which causes concatenation errors
end
%set(handles.listbox_selectedMaskChannels,'String',channelString,'UserData',channelIndex);
set(handles.listbox_selectedChannels,'String',channelString,'UserData',channelIndex);


% --- Executes during object creation, after setting all properties.
function popupmenu_SegProcessIndex_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_SegProcessIndex (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in saveresultsin.
function saveresultsin_Callback(hObject, eventdata, handles)
% hObject    handle to saveresultsin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns saveresultsin contents as cell array
%        contents{get(hObject,'Value')} returns selected item from saveresultsin


% --- Executes during object creation, after setting all properties.
function saveresultsin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to saveresultsin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
