function ringMeanIntensity = getPerObjectRingIntensity(Mask, objectMask, Image, r1, r2)
% GETPEROBJECTRINGINTENSITY calculates the mean ring intensity for each
% object in a labeled mask. the input here includes an one object mask, a
% whole mask, and the image. r1 and r2 are dilation radius from the object,
% and they are defined inside the funtion ringMeanIntensitiesCalc.

% dilate objectMask by radius r2
objMaskD = imdilate(objectMask, strel('disk',r2, 0))>0;

% dilate wholeMask by radius r1
wholeMaskD = imdilate(Mask, strel('disk',r1, 0))>0;

% ring mask is objMaskD - wholeMaskD
ringMask = objMaskD&~wholeMaskD;

% get intensity info
ringMeanIntensity = mean(Image(ringMask));
