function [OutMat, AndLogic, OrLogic] = matrixCompare(PropsMatrix, LowerLimits, UpperLimits)
% MATRIXCOMPARE determines whether each colomn of PropsMatrix falls between
% the lowerLimits and upperlimits.
%check inputs:
if length(LowerLimits) ~= size(PropsMatrix,2) || length(UpperLimits) ~= size(PropsMatrix,2)
    error('Upper Limits or Lower Limits not in correct length.');
    return;
end
OutMat = bsxfun(@gt, PropsMatrix, LowerLimits)&bsxfun(@lt, PropsMatrix, UpperLimits);
AndLogic = sum(OutMat,2) == length(LowerLimits);
OrLogic = sum(OutMat,2) >0 ;
end