function varargout = specialSegProcessGUI(varargin)
%SPECIALSEGPROCESSGUI M-file for specialSegProcessGUI.fig
%      SPECIALSEGPROCESSGUI, by itself, creates a new SPECIALSEGPROCESSGUI or raises the existing
%      singleton*.
%
%      H = SPECIALSEGPROCESSGUI returns the handle to a new SPECIALSEGPROCESSGUI or the handle to
%      the existing singleton*.
%
%      SPECIALSEGPROCESSGUI('Property','Value',...) creates a new SPECIALSEGPROCESSGUI using the
%      given property value pairs. Unrecognized properties are passed via
%      varargin to specialSegProcessGUI_OpeningFcn.  This calling syntax produces a
%      warning when there is an existing singleton*.
%
%      SPECIALSEGPROCESSGUI('CALLBACK') and SPECIALSEGPROCESSGUI('CALLBACK',hObject,...) call the
%      local function named CALLBACK in SPECIALSEGPROCESSGUI.M with the given input
%      arguments.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help specialSegProcessGUI

% Last Modified by GUIDE v2.5 26-Feb-2015 17:40:33

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @specialSegProcessGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @specialSegProcessGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
   gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before specialSegProcessGUI is made visible.
function specialSegProcessGUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   unrecognized PropertyName/PropertyValue pairs from the
%            command line (see VARARGIN)

processGUI_OpeningFcn(hObject, eventdata, handles, varargin{:},'initChannel',1);
% Set-up parameters
userData=get(handles.figure1,'UserData');
funParams = userData.crtProc.funParams_;
methodSelection = funParams.methodSelection;
paramNames = userData.crtProc.getParamnames('methodSelection', methodSelection);
%paramNames = userData.crtProc.getParamnames; % initially use method = 1; update each time method is changed.
% Update GUI user data
set(handles.figure1, 'UserData', userData);
threshMethods = userData.crtProc.getMethods();
set(handles.methodSelection,'String',{threshMethods(:).name},...
    'Value',funParams.methodSelection);
% set paramNtext
for i = 1:5 % left 5 spots for parameters in GUI, modify it if changed
tagStringText{i} = ['param', num2str(i),'text' ];
tagStringParam{i} = ['param', num2str(i)];
end

for i = 1:length(paramNames)
    set(handles.(tagStringText{i}),'String',paramNames{i});
    set(handles.(tagStringParam{i}),'String',num2str(funParams.(paramNames{i})));
    set(handles.(tagStringText{i}),'Visible','on');
    set(handles.(tagStringParam{i}),'Visible','on');
end
for i = length(paramNames)+1:1:length(tagStringText)
    set(handles.(tagStringText{i}),'Visible','off');
    set(handles.(tagStringParam{i}),'Visible','off');
end
%update_data(hObject,eventdata,handles);
handles.output = hObject;
guidata(hObject, handles);
% UIWAIT makes specialSegProcessGUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = specialSegProcessGUI_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton_done.
function pushbutton_done_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_done (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if isempty(get(handles.listbox_selectedChannels, 'String'))
    errordlg('Please select at least one input channel from ''Available Channels''.','Setting Error','modal')
    return;
end

%Get selected image channels
channelIndex = get(handles.listbox_selectedChannels, 'Userdata');
if isempty(channelIndex)
    errordlg('Please select at least one input channel from ''Available Channels''.','Setting Error','modal')
    return;
end
funParams.ChannelIndex = channelIndex;
funParams.methodSelection=get(handles.methodSelection,'Value');

for i = 1:5 % left 5 spots for parameters in GUI, modify it if changed
tagStringText{i} = ['param', num2str(i),'text' ];
tagStringParam{i} = ['param', num2str(i)];
end
for i = 1:5
    if strcmp(get(handles.(tagStringParam{i}),'Visible'), 'on')
        funparamsname = get(handles.(tagStringText{i}), 'String');
        funParams.(funparamsname) = str2double(get(handles.(tagStringParam{i}),'String'));
    end
end

% % if mario
% if funParams.methodSelection == 1
%     funParams.thPaper=str2double(get(handles.param1,'String'));
%     funParams.maxRect=str2double(get(handles.param2,'String'));
%     funParams.minSpotArea=str2num(get(handles.param3,'String'));
% end

% Add 64-bit warning
is64bit = ~isempty(regexp(computer ,'64$', 'once'));
if ~is64bit
    warndlg(['Your Matlab version is not detected as 64-bit. Please note '....
        'the point source detection uses compiled MEX files which '...
        'are not provided for 32-bit.'],...
        'Setting Error','modal');
end
handles.output = hObject;
guidata(hObject, handles);
processGUI_ApplyFcn(hObject, eventdata, handles,funParams);


% --- Executes on key press with focus on pushbutton_done and none of its controls.
function pushbutton_done_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to pushbutton_done (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
if strcmp(eventdata.Key, 'return')
    pushbutton_done_Callback(handles.pushbutton_done, [], handles);
end


% --- Executes during object deletion, before destroying properties.
function figure1_DeleteFcn(hObject, ~, handles)
% Notify the package GUI that the setting panel is closed
userData = get(handles.figure1, 'UserData');

if isfield(userData, 'helpFig') && ishandle(userData.helpFig)
   delete(userData.helpFig) 
end

set(handles.figure1, 'UserData', userData);
guidata(hObject,handles);




% --- Executes on selection change in methodSelection.
function methodSelection_Callback(hObject, eventdata, handles)
% hObject    handle to methodSelection (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns methodSelection contents as cell array
%        contents{get(hObject,'Value')} returns selected item from methodSelection
update_data(hObject,eventdata,handles);


% --- Executes during object creation, after setting all properties.
function methodSelection_CreateFcn(hObject, eventdata, handles)
% hObject    handle to methodSelection (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function update_data(hObject, eventdata, handles)

% -------- Check user input --------

if isempty(get(handles.listbox_selectedChannels, 'String'))
    errordlg('Please select at least one input channel from ''Available Channels''.','Setting Error','modal')
    return;
end


%Get selected image channels
channelIndex = get(handles.listbox_selectedChannels, 'Userdata');
if isempty(channelIndex)
    errordlg('Please select at least one input channel from ''Available Channels''.','Setting Error','modal')
    return;
end

%
methodSelection = get(handles.methodSelection, 'Value');
userData=get(handles.figure1,'UserData');
[paramNames,funParams] = userData.crtProc.getParamnames('methodSelection', methodSelection); % initially use method = 1; update each time method is changed.
% Update GUI user data
set(handles.figure1, 'UserData', userData);

% set paramNtext
for i = 1:5 % left 5 spots for parameters in GUI, modify it if changed
tagStringText{i} = ['param', num2str(i),'text' ];
tagStringParam{i} = ['param', num2str(i)];
end

for i = 1:length(paramNames)
    set(handles.(tagStringText{i}),'Visible','on');
    set(handles.(tagStringParam{i}),'Visible','on');
    set(handles.(tagStringText{i}),'String',paramNames{i});
    set(handles.(tagStringParam{i}),'String',num2str(funParams.(paramNames{i})));
end
for i = length(paramNames)+1:1:length(tagStringText)
    set(handles.(tagStringText{i}),'Visible','off');
    set(handles.(tagStringParam{i}),'Visible','off');
end


% Add 64-bit warning
is64bit = ~isempty(regexp(computer ,'64$', 'once'));
if ~is64bit
    warndlg(['Your Matlab version is not detected as 64-bit. Please note '....
        'the point source detection uses compiled MEX files which '...
        'are not provided for 32-bit.'],...
        'Setting Error','modal');
end
handles.output = hObject;
guidata(hObject, handles);



function param1_Callback(hObject, eventdata, handles)
% hObject    handle to param1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of param1 as text
%        str2double(get(hObject,'String')) returns contents of param1 as a double


% --- Executes during object creation, after setting all properties.
function param1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to param1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function param2_Callback(hObject, eventdata, handles)
% hObject    handle to param2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of param2 as text
%        str2double(get(hObject,'String')) returns contents of param2 as a double


% --- Executes during object creation, after setting all properties.
function param2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to param2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function param3_Callback(hObject, eventdata, handles)
% hObject    handle to param3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of param3 as text
%        str2double(get(hObject,'String')) returns contents of param3 as a double


% --- Executes during object creation, after setting all properties.
function param3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to param3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function param4_Callback(hObject, eventdata, handles)
% hObject    handle to param4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of param4 as text
%        str2double(get(hObject,'String')) returns contents of param4 as a double


% --- Executes during object creation, after setting all properties.
function param4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to param4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function param5_Callback(hObject, eventdata, handles)
% hObject    handle to param5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of param5 as text
%        str2double(get(hObject,'String')) returns contents of param5 as a double


% --- Executes during object creation, after setting all properties.
function param5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to param5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
