function wirtePropertyCSVforObjectPairs(objectPairs, MPropsC, filePath, fileHeader)
%WIRTEPROPERTYCSVFOROBJECTPAIRS prints .CSV files for each property of each
%objectPair in maskObjectPairing step. Input includes the objectPairs in
%cellarrys of structs, MPropsC object storing all property infos, and
%filePath. fileHeader is left in this function because maskObjectPairing
%needs multiple sheet to be printed. fileHeader isto distinguish each of
%them.
%filePath = 'propListsfilehaha.csv';
fileID = fopen([filePath,filesep,fileHeader,'Paired_Object_Properties.csv'], 'w');
fileIDCount = fopen([filePath,filesep,fileHeader,'Paired_Object_Count.csv'], 'w');
for i1 = 1:length(objectPairs) %multiple images in one channel
    
        currPairs = objectPairs{i1};
        [nucCol, MicroNucCol, MicroNucColCSV, PNucNum, NumOfMicroNuc] = populatecolumns(currPairs);
        ThresholdableMatrix = MPropsC.Results(i1).thresholdableMatrix;
        ThresholdableMatrix = ThresholdableMatrix(MicroNucCol,:);
        % write the headers in first line
        if i1 == 1
            fprintf(fileID, 'Image Number, Nuclei Number, Micro Nuclei Number,');
            fprintf(fileIDCount, 'Image Number, Nuclei Number, Micro Nuclei Number,\n');
            formatSpecCount = '%d, %d, %d, \n';
            % make formatSpec
            formatSpec = '%d, %d, %d,';
            [~, ThresholdableProps] = MPropsC.getThresholdableResults;
            
            for i3 = 1:length(ThresholdableProps)
                fprintf(fileID, [ThresholdableProps{i3},',']);
                formatSpec = [formatSpec, '%f,'];
            end
            formatSpec = [formatSpec, '\n'];
        end
        %% pixel size conversion are now done at maskpropscalc.saveResults step!!!
%         for i2 = 1:length(ThresholdableProps)
%             propLists = strcmp(ThresholdableProps{i2}, MPropsC.getAllList);
%             if sum(propLists)>0
%                 if find(propLists>0) == 1 ||find(propLists>0) == 10 || find(propLists>0) == 11 %areas
%                     ThresholdableMatrix(:,i2) = ThresholdableMatrix(:,i2).*(pixelsize^2);
%                 elseif find(propLists>0) == 20 ||find(propLists>0) == 21 || find(propLists>0) == 22 %length
%                     ThresholdableMatrix(:,i2) = ThresholdableMatrix(:,i2).*(pixelsize);
%                 end
%             end
%         end
%%
        fprintf(fileID, '\n');
        ImageNumber = i1*ones(size(nucCol));
        MatrixtoWrite = [double(ImageNumber),double(nucCol),double(MicroNucColCSV),ThresholdableMatrix];
        fprintf(fileID,formatSpec,MatrixtoWrite');
        MatrixtoWrite = [];
        ThresholdableMatrix = [];
        ImageNumberForCounting = i1*ones(size(PNucNum));
        MatrixtoWriteForCounting = [double(ImageNumberForCounting);double(PNucNum);double(NumOfMicroNuc)]';
        if ~isempty(MatrixtoWriteForCounting)
        fprintf(fileIDCount,formatSpecCount,MatrixtoWriteForCounting');
        else
            fprintf(fileIDCount, '\n');
        end
end