function fileID = wirtePropertyCSVforObjects(ImageNumber, objectNumbers, MPropsC, filePath, fileHeader, fileID)
%WIRTEPROPERTYCSVFOROBJECTS writes a CSV sheet for all available results in
%MPropsC (the object storing all property calculation info) FOR EACH IMAGE, ONE BY ONE.
%Input includes the objectPairs in
%cellarrys of structs, MPropsC object storing all property infos, and
%filePath. fileHeader is left in this function because maskObjectPairing
%needs multiple sheet to be printed. fileHeader isto distinguish each
%of them. fileID is passed in when it is not for the first image, in order
%to append information to the end of the file.
if isempty(fileID)
    fileID = fopen([filePath,fileHeader,'Object_Properties.csv'], 'w');
end
for i1 = 1:length(objectNumbers)-1 %multiple images in one channel
    ThresholdableMatrix = MPropsC.Results(ImageNumber).thresholdableMatrix;
    ThresholdableMatrix = ThresholdableMatrix(i1,:);
    % write the headers in first line
    if i1 == 1 
        if ImageNumber == 1
            fprintf(fileID, 'Image Number, Object Number,');
        end
        % make formatSpec
        formatSpec = '%d, %d, %d,';
        [~, ThresholdableProps] = MPropsC.getThresholdableResults;
        for i3 = 1:length(ThresholdableProps)
            if ImageNumber == 1
                fprintf(fileID, [ThresholdableProps{i3},',']);
            end
            formatSpec = [formatSpec, '%f,'];
        end
        formatSpec = [formatSpec, '\n'];
    end
    fprintf(fileID, '\n');
    MatrixtoWrite = [double(ImageNumber),double(i1),ThresholdableMatrix];
    fprintf(fileID,formatSpec,MatrixtoWrite');
    MatrixtoWrite = [];
    ThresholdableMatrix = [];
end
fprintf(fileID, '\n');
end